image: docker:latest
services:
  - docker:dind

stages:
  - build
  - package
  - deploy

cache: &global_cache
  policy: pull-push
  paths:
    - node_modules/

variables:
  DOCKER_DRIVER: overlay2

build_dev:
  image: node:12
  stage: build
  variables:
    PROFILE: 'stage'
    BASE_URL: 'https://web.api.stage.ryzom.com'
    I18N_URL: 'https://web.api.ryzom.com'
  before_script:
    - "yarn install --frozen-lockfile"
  script: "yarn build"
  artifacts:
    paths:
      - ".nuxt"
  only:
    - dev

build_live:
  image: node:12
  stage: build
  variables:
    PROFILE: 'live'
    BASE_URL: 'https://web.api.ryzom.com'
    I18N_URL: 'https://web.api.ryzom.com'
  before_script:
    - "yarn install --frozen-lockfile"
  script: "yarn build"
  artifacts:
    paths:
      - ".nuxt"
  only:
    - master

dockerize_dev:
  stage: package
  cache:
    <<: *global_cache
    policy: pull
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --build-arg API_URL=https://web.api.stage.ryzom.com --build-arg LANG_URL=https://web.api.ryzom.com --cache-from $CI_REGISTRY_IMAGE:latest -t $CI_REGISTRY/ryzom/web/website:latest .
    - docker push $CI_REGISTRY/ryzom/web/website:latest
  only:
    - dev

dockerize_live:
  stage: package
  cache:
    <<: *global_cache
    policy: pull
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CI_REGISTRY_IMAGE:live || true
    - docker build --build-arg API_URL=https://web.api.ryzom.com --build-arg LANG_URL=https://web.api.ryzom.com --cache-from $CI_REGISTRY_IMAGE:live -t $CI_REGISTRY/ryzom/web/website:live .
    - docker push $CI_REGISTRY/ryzom/web/website:live
  only:
    - master

deploy_dev:
  image: curlimages/curl
  stage: deploy
  cache: {}
  dependencies: []
  script:
    #    - curl -X POST $PORTAINER_HOOK_DEV
    - curl -X POST $PORTAINER_HOOK_COTARE
  only:
    - dev

#deploy_live:
#  image: curlimages/curl
#  stage: deploy
#  cache: {}
#  dependencies: []
#  script:
#    - curl -X POST $PORTAINER_HOOK_LIVE
#  only:
#    - master
